#!/usr/bin/perl
#################################################################################
# Prepare data about perl script to be inserted into the database
#
# uses perldeps.pl from the rpm-build package
#
##################################################################################
use strict;

use Getopt::Long;
use File::Basename;

require "./interpreted languages/perldeps.pl";

my $argc = @ARGV;
die "Usage $0  [filename(s)]\n" if $argc == 0;

my $deps = new DependencyParser;
for my $file (grep /^[^-]/, @ARGV) {
  $deps->process_file($file);

  for my $req ($deps->requires) {
    my $value = $req->value;
    print "  PerlModuleUsed: ".$req->value."\n";
  }
}


