#!/usr/bin/perl -w

# Moblin Application Checker
# Upload Form Module (upload_data.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use File::Temp qw/tmpnam/;

autoflush_on();

if ($_POST{'send_data'} or $_POST{'save_as'}) {
	# Perform data transfer
	my $result_text = '';
	my $res_dir = '';
	if ($_GET{'details'}) {
		$res_dir = $CONFIG{'RESULTS_DIR'}.'/'.$_GET{'details'};
	}
	elsif ($_POST{'details'}) {
		$res_dir = $CONFIG{'RESULTS_DIR'}.'/'.$_POST{'details'};
		$_GET{'details'} = $_POST{'details'};
	}
	if (($res_dir ne '') and ($_POST{'upload_file'})) {
		if (open(INFO_FILE, ">$res_dir/APP_INFO")) {
			print INFO_FILE "Contact name: $_POST{'contact_name'}\n";
			print INFO_FILE "E-mail: $_POST{'email'}\n";
			print INFO_FILE "Application name: $_POST{'app_name'}\n";
			print INFO_FILE "Application version: $_POST{'app_version'}\n";
			print INFO_FILE "Category: $_POST{'category'}\n";
			print INFO_FILE "User interface style: $_POST{'ui'}\n";
			print INFO_FILE "License type: $_POST{'lic'}\n";
			print INFO_FILE "Application homepage: $_POST{'homepage'}\n";
			print INFO_FILE "Comments:\n";
			print INFO_FILE $_POST{'comments'};
			close(INFO_FILE);
		}
		my $tarball_name = $_POST{'app_name'};
		$tarball_name .= "_$_POST{'app_version'}" if ($_POST{'app_version'});
		$tarball_name .= '_upload_data_';
		my $timestamp = $_GET{'details'};
		$timestamp =~ s/^.*-(\d{4})-(\d{2})-(\d{2})-(\d{2})h-(\d{2})m-(\d{2})s$/$1$2$3$4$5$6/;
		$tarball_name .= $timestamp;
		unlink("/tmp/$tarball_name.tar.gz");
		my $tgz_error = tmpnam();
		if (!-f "/tmp/$tarball_name.tar.gz") {
			system(esc_cmdline("cd «$res_dir»; tar czf «/tmp/$tarball_name.tar.gz» «$_POST{'upload_file'}» APP_INFO --force-local >«$tgz_error» 2>&1"));
			if (!$?) {
				if ($_POST{'send_data'}) {
					print 'HTTP/1.0 200 OK' . CRLF;
					print 'Content-type: text/html' . CRLF . CRLF;

					print_header('Upload Results to the Linux Foundation', 'upload');

					print <<DATA;
<div id="progress_info">
<font color="green"><b>Please wait while the file is being uploaded...</b></font><br />
Time elapsed: <span id="timer">00:00</span>
</div>

<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = 0;
function update_timer() {
	++elapsed_time;
	var elem = document.getElementById('timer');
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = '';
		tmp += (m < 10) ? '0' + m : m;
		tmp += ':';
		tmp += (s < 10) ? '0' + s : s;
		elem.innerHTML = tmp;
		setTimeout('update_timer()', 1000);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>
DATA
					my $upload_out = tmpnam();
					my $upload_err = tmpnam();
					system(esc_cmdline("«$CONFIG{'UTILS_DIR'}/upload.pl» «/tmp/$tarball_name.tar.gz» 1>«$upload_out» 2>«$upload_err»"));
					if (!$?) {
						# Success
						$result_text = '<b><font color="green">Uploading finished successfully!</font></b><br />You will be notified by E-mail when the application is added to the Moblin Navigator database.';
						if (open(FTP_UPLOAD, ">$res_dir/test_logs/ftp_upload")) {
							print FTP_UPLOAD '1';
							close(FTP_UPLOAD);
						}
					}
					else {
						# Fail
						$result_text = read_file($upload_err);
						if ($result_text eq '') {
							$result_text = '<b><font color="red">Upload failed!</font></b>';
						}
						else {
							$result_text = esc_html($result_text);
							$result_text =~ s|^([^\n]*)|<font color="red">$1</font>|;
							$result_text =~ s|\n|<br />|g;
							$result_text = "<b>$result_text</b>";
						}
					}
					unlink($upload_out);
					unlink($upload_err);
					unlink("/tmp/$tarball_name.tar.gz");
				}
				else {
					if (open(TARBALL, "/tmp/$tarball_name.tar.gz")) {
						my $sz = -s "/tmp/$tarball_name.tar.gz";
						print 'HTTP/1.0 200 OK' . CRLF;
						print 'Content-type: application/x-gzip' . CRLF;
						print 'Content-Disposition: attachment; filename="' . $tarball_name . '.tar.gz"' . CRLF;
						print 'Content-Length: ' . $sz  . CRLF;
						print CRLF;
						my $data;
						while (read(TARBALL, $data, 4096)) {
							print $data;
						}
						close(TARBALL);
						unlink("/tmp/$tarball_name.tar.gz");
						unlink($tgz_error);
						exit;
					}
					else {
						print 'HTTP/1.0 200 OK' . CRLF;
						print 'Content-type: text/html' . CRLF . CRLF;

						print_header('Upload Results to the Linux Foundation', 'upload');

						$result_text = '<b><font color="red">Could not open tar.gz!</font></b>';
						unlink("/tmp/$tarball_name.tar.gz");
					}
				}
			}
			else {
				print 'HTTP/1.0 200 OK' . CRLF;
				print 'Content-type: text/html' . CRLF . CRLF;

				print_header('Upload Results to the Linux Foundation', 'upload');

				my $msg = esc_html(read_file($tgz_error));
				$msg =~ s/\r\n/<br \/>/g;
				$msg =~ s/\n/<br \/>/g;
				$result_text = "<b><font color=\"red\">Error while creating tar.gz!</font><br />$msg</b>";
			}
			unlink($tgz_error);
		}
		else {
			print 'HTTP/1.0 200 OK' . CRLF;
			print 'Content-type: text/html' . CRLF . CRLF;

			print_header('Upload Results to the Linux Foundation', 'upload');

			$result_text = "<b><font color=\"red\">Error while overwriting old tar.gz!</font></b>";
		}
		print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished=1;
var elem_progress_info = document.getElementById('progress_info');
if (elem_progress_info)
	elem_progress_info.style.display = 'none';
// ]]>
</script>
DATA
	}
	else {
		$result_text = '<b><font color="red">The test run data to be sent are not specified!</font></b>';
	}
	print "<h1>Upload Data to the Linux Foundation</h1>\n$result_text\n<br /><br /><a href=\"tests_results.pl?details=$_GET{details}\">Back to the test results page</a>";
}
elsif ($_GET{'details'}) {
	# Show the upload form
	my $app_name = '';
	my $res_dir = $CONFIG{'RESULTS_DIR'}.'/'.$_GET{'details'};
	if (open(FILE, "$res_dir/INFO")) {
		while (<FILE>) {
			if (m/Application: (.*)$/) {
				$app_name = esc_html($1);
				last;
			}
		}
		close(FILE);
	}
	my $host_platform = read_file("$res_dir/test_logs/host_platform");
	my $moblin_version = read_file("$res_dir/test_logs/moblin_version");
	$host_platform =~ s/[\r\n]//g;
	$moblin_version =~ s/[\r\n]//g;
	my $f_host_platform = lc($host_platform);
	my $test_run_html = esc_html($_GET{'details'});

	my $warning = '';
	if (-f "$res_dir/test_logs/ftp_upload") {
		$warning = "<font color=\"red\">You have already uploaded results of this analysis. Thank you!</font><br />";
	}

	print 'HTTP/1.0 200 OK' . CRLF;
	print 'Content-type: text/html' . CRLF . CRLF;

	print_header('Upload Results to the Linux Foundation', 'upload');

	print <<DATA;
<h1>Upload Application Data to the Linux Foundation</h1>

$warning
This form allows you to upload data about your application to the Linux Foundation. The data includes the lists of external libraries and interfaces that your application needs from Linux distributions. This will be published in the <a href="http://dev.linuxfoundation.org/moblin-navigator/browse/app.php" target="_blank">Moblin Navigator</a> and will be used when making decisions for future versions of the Moblin standard (e.g. deprecating poorly used interfaces and adding popular ones).
<br /><br />
You can upload the data using this form or use <b>Save As&hellip;</b> to e-mail it as attachment to <a href="mailto:lsb-appcheck-support\@linuxfoundation.org">lsb-appcheck-support\@linuxfoundation.org</a>.
<br /><br />

<form method="post" action="upload_data.pl" name="upload_form">
<input type="hidden" name="details" value="$test_run_html" />
<input type="hidden" name="upload_file" value="${app_name}_${f_host_platform}_upload_data" />
<div style="width: 50em;">
<table border="0" cellpadding="2" cellspacing="2" width="100%">
  <tr><td style="white-space: nowrap;">Contact name: <font color="red">*</font></td><td width="100%"><input type="text" name="contact_name" id="contact_name" value="" style="width: 100%;" onfocus="javascript:style.borderColor='';" /></td></tr>
  <tr><td style="white-space: nowrap;">E-mail: <font color="red">*</font></td><td><input type="text" name="email" id="email" value="" style="width: 100%;" onfocus="javascript:style.borderColor='';" /></td></tr>
  <tr><td style="white-space: nowrap;">Application name: <font color="red">*</font></td><td><input type="text" name="app_name" id="app_name" value="$app_name" style="width: 100%;" onfocus="javascript:style.borderColor='';" /></td></tr>
  <tr><td style="white-space: nowrap;">Application version:</td><td><input type="text" name="app_version" id="app_version" value="" style="width: 100%;" /></td></tr>
  <tr><td style="white-space: nowrap;">Category: <font color="red">*</font></td>
    <td>
      <select name="category" id="category" style="width: 50%; border: 1px solid #cccccc;" onfocus="javascript:style.borderColor='#cccccc';">
        <option value="" selected="selected">* Select one *</option>
        <option value="Accessibility and i18n">Accessibility and i18n</option>
        <option value="Antivirus and Security">Antivirus and Security</option>
        <option value="Emulators">Emulators</option>
        <option value="Office and Desktop">Office and Desktop</option>
        <option value="Data Management">Data Management</option>
        <option value="Development">Development</option>
        <option value="Games">Games</option>
        <option value="Multimedia and Graphics">Multimedia and Graphics</option>
        <option value="Network">Network</option>
        <option value="Science and Education">Science and Education</option>
        <option value="System Tools">System Tools</option>
        <option value="X11 Utilities">X11 Utilities</option>
      </select>
    </td>
  </tr>
  <tr><td style="white-space: nowrap;">User interface style: <font color="red">*</font></td>
    <td>
      <table id="ui_border" style="border: 1px solid white; width: 100%;" cellpadding="0" cellspacing="0"><tr>
        <td width="33%"><label><input type="radio" name="ui" id="gui" value="Graphical UI" onclick="javascript:clear_border('ui');" /> Graphical UI</label></td>
        <td width="33%"><label><input type="radio" name="ui" id="cui" value="Console UI" onclick="javascript:clear_border('ui');" /> Console UI</label></td>
        <td width="33%"></td>
      </tr></table>
    </td>
  </tr>
  <tr><td style="white-space: nowrap;">License type: <font color="red">*</font></td>
    <td>
      <table id="lic_border" style="border: 1px solid white; width: 100%;" cellpadding="0" cellspacing="0"><tr>
        <td width="33%"><label><input type="radio" name="lic" id="lic_os" value="Open Source" onclick="javascript:clear_border('lic');" /> Open Source</label></td>
        <td width="33%"><label><input type="radio" name="lic" id="lic_prop" value="Proprietary" onclick="javascript:clear_border('lic');" /> Proprietary</label></td>
        <td width="33%"><label><input type="radio" name="lic" id="lic_mixed" value="Mixed" onclick="javascript:clear_border('lic');" /> Mixed</label></td>
      </tr></table>
    </td>
  </tr>
  <tr><td style="white-space: nowrap;">Application homepage:</td><td><input type="text" name="homepage" id="homepage" value="" style="width: 100%;" /></td></tr>
  <tr><td valign="top" style="white-space: nowrap;">Comments:</td><td><textarea name="comments" id="comments" rows="5" cols="58" style="width: 100%;"></textarea></td></tr>
</table>
<p align="center"><br /><br />
<input type="submit" name="send_data" value="Send Data" style="width: 8em;" onclick="javascript:return check_form();" />&nbsp;&nbsp;&nbsp;<input type="submit" name="save_as" value="Save As..." style="width: 8em;" onclick="javascript:return check_form();" />
</p>
</div>
</form>

<script language="javascript" type="text/javascript">
// <![CDATA[
function clear_border(id) {
	var elem = document.getElementById(id + '_border');
	if (elem)
		elem.style.borderColor = 'white';
}

function check_form() {
	var fields = new Array('contact_name', 'email', 'app_name', 'category');
	var field_names = new Array('Contact name', 'E-mail', 'Application name', 'Category');
	var radios = new Array(new Array('ui', 'gui', 'cui'), new Array('lic', 'lic_os', 'lic_prop'));
	var radio_names = new Array('User interface', 'License type');
	var fails = '';
	var fails_present = false;
	for (var i=0; i<fields.length; ++i) {
		var elem = document.getElementById(fields[i]);
		if (elem) {
			if (elem.value == '') {
				elem.style.borderColor = 'red';
				fails += '\\n' + field_names[i];
				fails_present = true;
			}
		}
	}
	for (var i=0; i<radios.length; ++i) {
		var checked_elem;
		var elem;
		for (var j=1; j<radios[i].length; ++j) {
			checked_elem = false;
			elem = document.getElementById(radios[i][j]);
			if (elem && elem.checked) {
				checked_elem = true;
				break;
			}
		}
		if (!checked_elem) {
			elem = document.getElementById(radios[i][0] + '_border');
			if (elem) {
				elem.style.borderColor = 'red';
				fails += '\\n' + radio_names[i];
				fails_present = true;
			}
		}
	}
	if (fails_present) {
		alert('The following fields should be specified:' + fails);
		return false;
	}
	else
		return true;
}
// ]]>
</script>

DATA
}
else {
	print 'HTTP/1.0 200 OK' . CRLF;
	print 'Content-type: text/html' . CRLF . CRLF;

	print_header('Upload Results to the Linux Foundation', 'upload');

	print "<h1>Upload Data to the Linux Foundation</h1>\n<b><font color=\"red\">The test run data to be sent are not specified!</font></b>\n";
}

print_footer();
